import type { Handler } from 'express';
import type { Schema } from 'zod';
import type { ExpressOpenAPIPlugin, RouteProcessor } from '..';
import type { RequestSegment, ResponseSegment } from '../../types';
import type { SpecificationSchema } from './types';
export type { Request, RequestHandler, RequestSegmentType, Response, ResponseSegmentType, SpecificationSchema, } from './types';
type SpecInfo = {
    operationId?: string;
    req: Map<RequestSegment, Schema<any> | undefined>;
    res: Map<string, {
        [segment in ResponseSegment]?: Schema<any>;
    } | undefined>;
};
export type GetSpecificationMiddleware = (schema: SpecificationSchema) => Handler;
type SpecificationPlugin = ExpressOpenAPIPlugin<SpecInfo, GetSpecificationMiddleware>;
/**
 * @deprecated Use `SpecificationPlugin.create`
 */
export declare const getSpecificationPlugin: ({ req: reqConfig, res: resConfig, }?: {
    req?: {
        segmentOrder?: RequestSegment[];
        skipValidation?: boolean;
    };
    res?: {
        segmentOrder?: ResponseSegment[];
        skipValidation?: boolean;
    };
}) => SpecificationPlugin;
export declare const SpecificationPlugin: {
    create: ({ req: reqConfig, res: resConfig, }?: {
        req?: {
            segmentOrder?: RequestSegment[];
            skipValidation?: boolean;
        };
        res?: {
            segmentOrder?: ResponseSegment[];
            skipValidation?: boolean;
        };
    }) => SpecificationPlugin;
    routeProcessor: RouteProcessor<SpecInfo>;
};
