import type { ZodError } from 'zod';
import type { RequestSegment, ResponseSegment } from '../types';
export declare class RequestValidationError extends Error {
    segment: RequestSegment;
    validationError: ZodError;
    constructor(validationError: ZodError, segment: RequestSegment);
}
export declare class ResponseValidationError extends Error {
    segment: ResponseSegment;
    validationError: ZodError;
    constructor(validationError: ZodError, segment: ResponseSegment);
}
